#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;



namespace FilterTemplate {

	public ref class SettingsForm : public System::Windows::Forms::Form
	{
	public:
		filtersettings* FilterSetting;
		bool FilterCancelled, init;

	private: 
		System::Windows::Forms::Button^			ButtonApply;
		System::Windows::Forms::Button^			ButtonCancel;
		System::Windows::Forms::CheckBox^		CheckBoxRemoveSurfaceColors;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexCheck;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexNew;
		System::Windows::Forms::HScrollBar^		ScrollBarRadius;
		System::Windows::Forms::HScrollBar^		ScrollBarMinimumOccurence;
		System::Windows::Forms::Label^			label1;
		System::Windows::Forms::Label^			label3;
		System::Windows::Forms::Label^			label4;
		System::Windows::Forms::Label^			label5;
		System::Windows::Forms::Label^			LabelIndexCheck;
		System::Windows::Forms::Label^			LabelIndexNew;
		System::Windows::Forms::Label^			LabelRadius;
		System::Windows::Forms::Label^			LabelMinimumOccurence;
		System::Windows::Forms::PictureBox^		PictureBoxCheckColor;
		System::Windows::Forms::PictureBox^		PictureBoxNewColor;
		System::ComponentModel::IContainer^		components;

	public:
		SettingsForm(filtersettings* fs)
		{
			InitializeComponent();

			FilterSetting = fs;
			init = true;

			ScrollBarIndexCheck->Minimum         = 0;
			ScrollBarIndexCheck->Maximum         = 255;
			ScrollBarIndexCheck->Value           = fs->pixel_index_check;
			ScrollBarIndexNew->Minimum           = 0;
			ScrollBarIndexNew->Maximum           = 255;
			ScrollBarIndexNew->Value             = fs->pixel_index_new;
			ScrollBarRadius->Minimum             = 1;
			ScrollBarRadius->Maximum             = 10;
			ScrollBarRadius->Value               = fs->pixel_radius;
			CheckBoxRemoveSurfaceColors->Checked = (fs->pixel_remove_surfaces != 0);

			int size = fs->pixel_radius * 2 + 1;
			ScrollBarMinimumOccurence->Minimum   = 1;
			ScrollBarMinimumOccurence->Maximum   = size * size;
			ScrollBarMinimumOccurence->Value     = fs->pixel_minimum_occurence;
			init = false;

			Scroll_ValueChanged(nullptr, nullptr);

			FilterCancelled = true;
		}

	protected:

		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->LabelIndexCheck = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarIndexCheck = (gcnew System::Windows::Forms::HScrollBar());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarRadius = (gcnew System::Windows::Forms::HScrollBar());
			this->LabelRadius = (gcnew System::Windows::Forms::Label());
			this->PictureBoxCheckColor = (gcnew System::Windows::Forms::PictureBox());
			this->PictureBoxNewColor = (gcnew System::Windows::Forms::PictureBox());
			this->LabelIndexNew = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarIndexNew = (gcnew System::Windows::Forms::HScrollBar());
			this->CheckBoxRemoveSurfaceColors = (gcnew System::Windows::Forms::CheckBox());
			this->LabelMinimumOccurence = (gcnew System::Windows::Forms::Label());
			this->ScrollBarMinimumOccurence = (gcnew System::Windows::Forms::HScrollBar());
			this->label4 = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxCheckColor))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->BeginInit();
			this->SuspendLayout();
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(91, 246);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(172, 246);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// LabelIndexCheck
			// 
			this->LabelIndexCheck->AutoSize = true;
			this->LabelIndexCheck->ForeColor = System::Drawing::Color::White;
			this->LabelIndexCheck->Location = System::Drawing::Point(304, 177);
			this->LabelIndexCheck->Name = L"LabelIndexCheck";
			this->LabelIndexCheck->Size = System::Drawing::Size(13, 13);
			this->LabelIndexCheck->TabIndex = 17;
			this->LabelIndexCheck->Text = L"0";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->ForeColor = System::Drawing::Color::White;
			this->label3->Location = System::Drawing::Point(48, 160);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(89, 13);
			this->label3->TabIndex = 16;
			this->label3->Text = L"Pixel szn-indexe:";
			// 
			// ScrollBarIndexCheck
			// 
			this->ScrollBarIndexCheck->LargeChange = 1;
			this->ScrollBarIndexCheck->Location = System::Drawing::Point(51, 173);
			this->ScrollBarIndexCheck->Maximum = 255;
			this->ScrollBarIndexCheck->Name = L"ScrollBarIndexCheck";
			this->ScrollBarIndexCheck->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexCheck->TabIndex = 15;
			this->ScrollBarIndexCheck->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexCheck->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->ForeColor = System::Drawing::Color::White;
			this->label1->Location = System::Drawing::Point(48, 64);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(118, 13);
			this->label1->TabIndex = 18;
			this->label1->Text = L"Pixel krnyezeti sugara:";
			// 
			// ScrollBarRadius
			// 
			this->ScrollBarRadius->LargeChange = 1;
			this->ScrollBarRadius->Location = System::Drawing::Point(51, 77);
			this->ScrollBarRadius->Maximum = 10;
			this->ScrollBarRadius->Minimum = 1;
			this->ScrollBarRadius->Name = L"ScrollBarRadius";
			this->ScrollBarRadius->Size = System::Drawing::Size(250, 17);
			this->ScrollBarRadius->TabIndex = 19;
			this->ScrollBarRadius->Value = 1;
			this->ScrollBarRadius->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarRadius->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// LabelRadius
			// 
			this->LabelRadius->AutoSize = true;
			this->LabelRadius->ForeColor = System::Drawing::Color::White;
			this->LabelRadius->Location = System::Drawing::Point(304, 81);
			this->LabelRadius->Name = L"LabelRadius";
			this->LabelRadius->Size = System::Drawing::Size(19, 13);
			this->LabelRadius->TabIndex = 20;
			this->LabelRadius->Text = L"10";
			// 
			// PictureBoxCheckColor
			// 
			this->PictureBoxCheckColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxCheckColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxCheckColor->Location = System::Drawing::Point(12, 173);
			this->PictureBoxCheckColor->Name = L"PictureBoxCheckColor";
			this->PictureBoxCheckColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxCheckColor->TabIndex = 22;
			this->PictureBoxCheckColor->TabStop = false;
			// 
			// PictureBoxNewColor
			// 
			this->PictureBoxNewColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxNewColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxNewColor->Location = System::Drawing::Point(12, 216);
			this->PictureBoxNewColor->Name = L"PictureBoxNewColor";
			this->PictureBoxNewColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxNewColor->TabIndex = 26;
			this->PictureBoxNewColor->TabStop = false;
			// 
			// LabelIndexNew
			// 
			this->LabelIndexNew->AutoSize = true;
			this->LabelIndexNew->ForeColor = System::Drawing::Color::White;
			this->LabelIndexNew->Location = System::Drawing::Point(304, 220);
			this->LabelIndexNew->Name = L"LabelIndexNew";
			this->LabelIndexNew->Size = System::Drawing::Size(13, 13);
			this->LabelIndexNew->TabIndex = 25;
			this->LabelIndexNew->Text = L"0";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->ForeColor = System::Drawing::Color::White;
			this->label5->Location = System::Drawing::Point(48, 203);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(153, 13);
			this->label5->TabIndex = 24;
			this->label5->Text = L"Eltvoltott pixel j szn-indexe:";
			// 
			// ScrollBarIndexNew
			// 
			this->ScrollBarIndexNew->LargeChange = 1;
			this->ScrollBarIndexNew->Location = System::Drawing::Point(51, 216);
			this->ScrollBarIndexNew->Maximum = 255;
			this->ScrollBarIndexNew->Name = L"ScrollBarIndexNew";
			this->ScrollBarIndexNew->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexNew->TabIndex = 23;
			this->ScrollBarIndexNew->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexNew->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// CheckBoxRemoveSurfaceColors
			// 
			this->CheckBoxRemoveSurfaceColors->ForeColor = System::Drawing::Color::White;
			this->CheckBoxRemoveSurfaceColors->Location = System::Drawing::Point(31, 12);
			this->CheckBoxRemoveSurfaceColors->Name = L"CheckBoxRemoveSurfaceColors";
			this->CheckBoxRemoveSurfaceColors->Size = System::Drawing::Size(270, 49);
			this->CheckBoxRemoveSurfaceColors->TabIndex = 28;
			this->CheckBoxRemoveSurfaceColors->Text = L"128-as index alatti, a keresend pixel-indextl eltr pixelek eltvoltsa (szn" 
				L"osztlyozs esetben a 128 alatti indexek a felleti pixelek)";
			this->CheckBoxRemoveSurfaceColors->UseVisualStyleBackColor = true;
			this->CheckBoxRemoveSurfaceColors->CheckedChanged += gcnew System::EventHandler(this, &SettingsForm::CheckBoxRemoveSurfaceColors_CheckedChanged);
			// 
			// LabelMinimumOccurence
			// 
			this->LabelMinimumOccurence->AutoSize = true;
			this->LabelMinimumOccurence->ForeColor = System::Drawing::Color::White;
			this->LabelMinimumOccurence->Location = System::Drawing::Point(304, 130);
			this->LabelMinimumOccurence->Name = L"LabelMinimumOccurence";
			this->LabelMinimumOccurence->Size = System::Drawing::Size(19, 13);
			this->LabelMinimumOccurence->TabIndex = 31;
			this->LabelMinimumOccurence->Text = L"10";
			// 
			// ScrollBarMinimumOccurence
			// 
			this->ScrollBarMinimumOccurence->LargeChange = 1;
			this->ScrollBarMinimumOccurence->Location = System::Drawing::Point(51, 126);
			this->ScrollBarMinimumOccurence->Maximum = 10;
			this->ScrollBarMinimumOccurence->Minimum = 1;
			this->ScrollBarMinimumOccurence->Name = L"ScrollBarMinimumOccurence";
			this->ScrollBarMinimumOccurence->Size = System::Drawing::Size(250, 17);
			this->ScrollBarMinimumOccurence->TabIndex = 30;
			this->ScrollBarMinimumOccurence->Value = 1;
			this->ScrollBarMinimumOccurence->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarMinimumOccurence->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->ForeColor = System::Drawing::Color::White;
			this->label4->Location = System::Drawing::Point(48, 113);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(164, 13);
			this->label4->TabIndex = 29;
			this->label4->Text = L"Pixel minimum elfordulsi szma:";
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::SteelBlue;
			this->ClientSize = System::Drawing::Size(337, 286);
			this->Controls->Add(this->LabelMinimumOccurence);
			this->Controls->Add(this->ScrollBarMinimumOccurence);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->CheckBoxRemoveSurfaceColors);
			this->Controls->Add(this->PictureBoxNewColor);
			this->Controls->Add(this->LabelIndexNew);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->ScrollBarIndexNew);
			this->Controls->Add(this->PictureBoxCheckColor);
			this->Controls->Add(this->LabelRadius);
			this->Controls->Add(this->ScrollBarRadius);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->LabelIndexCheck);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->ScrollBarIndexCheck);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Kis krnyezeti elforduls pixelek trlse";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxCheckColor))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
		System::Void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}

		System::Void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) { this->Close(); }

		System::Void Scroll_Change(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			if (!init)
			{
				FilterSetting->pixel_index_check     = ScrollBarIndexCheck->Value;
				FilterSetting->pixel_index_new       = ScrollBarIndexNew->Value;
				FilterSetting->pixel_radius          = ScrollBarRadius->Value;
				FilterSetting->pixel_remove_surfaces = (CheckBoxRemoveSurfaceColors->Checked) ? 1 : 0;

				int size = FilterSetting->pixel_radius * 2 + 1;
				ScrollBarMinimumOccurence->Minimum     = 1;
				if (ScrollBarMinimumOccurence->Value > size * size) ScrollBarMinimumOccurence->Value = size * size;
				ScrollBarMinimumOccurence->Maximum     = size * size;
				FilterSetting->pixel_minimum_occurence = ScrollBarMinimumOccurence->Value;
			}
			LabelIndexCheck->Text       = ScrollBarIndexCheck->Value.ToString();
			LabelIndexNew->Text         = ScrollBarIndexNew->Value.ToString();
			LabelRadius->Text           = ScrollBarRadius->Value.ToString();
			LabelMinimumOccurence->Text = ScrollBarMinimumOccurence->Value.ToString();

			int r, g, b, index;

			index = FilterSetting->pixel_index_check;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxCheckColor->BackColor     = Color::FromArgb(r, g, b);

			index = FilterSetting->pixel_index_new;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxNewColor->BackColor     = Color::FromArgb(r, g, b);
		}

		System::Void Scroll_ValueChanged(System::Object^  sender, System::EventArgs^  e) { Scroll_Change(nullptr, nullptr); }
		System::Void CheckBoxRemoveSurfaceColors_CheckedChanged(System::Object^  sender, System::EventArgs^  e) { Scroll_Change(nullptr, nullptr); }
};
}
